<template>
  <div class="mobile-banner">
    <swiper
      v-if="!bannerLoading"
      :slides-per-view="1"
      :scrollbar="{ draggable: true }"
      :pagination="{ clickable: true }"
      :modules="modules"
      :navigation="true"
      :autoplay="{
        delay: 4000,
        disableOnInteraction: false,
      }"
      :loop="themeBannerForDisplay.length > 1 ? true : false"
      class="flex content-center custom-swiper-mobile d9bet-custom-banner w-full"
    >
      <swiper-slide v-for="(item, index) in themeBannerForDisplay" :key="index">
        <div class="aspect-[1118/500] w-full flex items-center">
          <nuxt-link :to="item.HyperLink">
            <img :src="item.ImagePath" class="object-center w-full mx-auto" />
          </nuxt-link>
        </div>
      </swiper-slide>
    </swiper>
  </div>
</template>
<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import { Autoplay, Navigation, Pagination } from "swiper";
import {
  IThemePropertiesFromApi,
  ThemePropertiesFromApiDto,
} from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

const bannerKeys: Record<string, string> = {
  HomeInitial: "lobby_banner",
  SportInitial: "sport_banner_",
  VirtualSportInitial: "virtual_sport_banner_",
  LiveCasinoInitial: "live_casino_banner_",
  GameInitial: "game_banner_",
  PokerInitial: "poker_banner_",
  CockfightInitial: "cockfight_banner_",
  PromotionInitial: "promotion_banner_",
};
export default defineComponent({
  name: "MBanner",
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    actived: {
      type: String,
      default: "HomeInitial",
    },
  },
  emits: ["hasBanner"],
  setup(props, { emit }) {
    const { themeProperties, actived } = toRefs(props);
    const themeName = computed((): string => store.state.selectedThemeName);
    const bannerKey = bannerKeys[actived.value]
      ? bannerKeys[actived.value]
      : bannerKeys.HomeInitial;
    const themeBannerForDisplay = computed(
      (): Array<ThemePropertiesFromApiDto> => {
        let banners = themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          bannerKey
        );
        if (actived.value === "SportInitial") {
          banners = banners.filter(
            (banner) => !banner.HtmlId.includes("virtual_")
          );
        }
        emit("hasBanner", banners.length > 0);
        return banners;
      }
    );
    const bannerLoading = computed(
      () => themeBannerForDisplay.value.length === 0
    );
    return {
      themeBannerForDisplay,
      bannerLoading,
      bannerKey,
      modules: [Autoplay, Pagination, Navigation],
      themeName,
    };
  },
});
</script>

<style scoped lang="scss">
.mobile-banner .d9bet-custom-banner {
  width: 100%;
  max-height: 175px;
  height: unset;
}
</style>
